<script setup lang="ts">
import { useSalaryStore } from '@/stores/salary'
import { useUserStore } from '@/stores/user'
import DialogSalary from './DialogSalary.vue'
import ReportSalaryDialog from './ReportSalaryDialog.vue'

import { ref, computed } from 'vue'

const salaryStore = useSalaryStore()
const userStore = useUserStore()
const currentDate = new Date();
const currentMonth = currentDate.toLocaleString('default', { month: 'long' });


const search = ref('')
const headers = [
  { key: 'idSalary', sortable: false, title: 'Salary Id' },
  { key: 'fullname', title: 'Fullname', sortable: false },
  { key: 'gender', title: 'Gender', sortable: false },
  { key: 'role', title: 'Role', sortable: false },
  { key: 'month', title: 'Month', sortable: false },
  { key: 'salarybaht', title: 'Salary (Baht)', sortable: false },
  { key: 'status', title: 'Status', sortable: false },
  { key: 'actions', title: 'Actions', sortable: false }
]

const combinedItems = computed(() => {
  return [
    ...userStore.users.map((user) => ({
      ...user,
      ...(salaryStore.salarys.find((salarys) => salarys.idSalary === user.id) || {
        idSalary: salaryStore.lastIndex++,
        salarybaht: user.role === 'manager' ? 25000 : 15000,
        month: currentMonth,
        status: ' Not Paid '
      })
    }))
  ]
})

</script>
<template>
  <v-row no-gutters>
    <v-col cols="12" md="5">
      <v-text-field
        v-model="search"
        density="compact"
        variant="solo"
        label="Search Salary"
        append-inner-icon="mdi-magnify"
        single-line
        hide-details
        style="width: 200px"
      >
      </v-text-field>
    </v-col>

    <v-col cols="6" style="padding-top: 0px">
      <v-btn prepend-icon="mdi-receipt-text" style="margin-left: 550px" @click="salaryStore.openReportSalaryDialog">Report Salary</v-btn>
    </v-col>

  </v-row>
  <v-data-table :headers="headers" :items-per-page="8" :items="combinedItems" :search="search">
    <template v-slot:[`item.actions`]="{ item }">
      <v-icon size="large" class="me-2" @click="salaryStore.editItem(item)"> mdi-cash </v-icon>
      
      

    </template>
  </v-data-table>

  <DialogSalary></DialogSalary>
  <ReportSalaryDialog></ReportSalaryDialog>
</template>
